#define _GNU_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "libpq-fe.h"

#include "config.h"


PGconn *conn;

/*
 * Proverqva dali opredelen chain trqbva da escape-va free zonite.
 * parametrite sa prefix-a na chain-a i posokata.
 * vrushta 0, ako ne trqbva da se pishat.
 */

int use_free_zone(char *pfx,char *dir)
{
	char query[512];
	PGresult *res;

	snprintf(query,512,"SELECT flags FROM chains WHERE name='%s_%s'",pfx,dir);
	res=PQexec(conn,query);
	return (strcmp(PQgetvalue(res,0,0),"nofree"));
}



int main()
{
	PGresult *res,*res1,*res_fr;
	char *query;
	int i,j;

	query=(char *) malloc(302);
	conn=PQsetdbLogin(DBHOST,NULL,NULL,NULL,DBNAME,DBUSER,DBPASS);
	res=PQexec(conn,"select value from config where name='acct_chain_pfx'");
	res_fr=PQexec(conn,"select ip,port,proto,iface from free_zones order by prio");

	for (i=0;i<PQntuples(res);i++)
	{

		printf("%s -F %s_in\n",IPCHAINS,PQgetvalue(res,i,0));
		printf("%s -F %s_out\n",IPCHAINS,PQgetvalue(res,i,0));
		/* Free zones */
		if ( (use_free_zone(PQgetvalue(res,i,0),"in")!=0) && (use_free_zone(PQgetvalue(res,i,0),"out")!=0) )
			for (j=0;j<PQntuples(res_fr);j++)
			{

				snprintf(query,200,"%s -A %s_in -j RETURN -d %s ",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res_fr,j,0));
				if (strlen(PQgetvalue(res_fr,j,2))>0)
				{
					strcat(query," --protocol ");
					strcat(query,PQgetvalue(res_fr,j,2));
				}

				if (strlen(PQgetvalue(res_fr,j,1))>0)
				{
					strcat(query," --destination-port ");
					strcat(query,PQgetvalue(res_fr,j,1));
				}

				if (strlen(PQgetvalue(res_fr,j,3))>0)
				{
					strcat(query," --in-interface ");
					strcat(query,PQgetvalue(res_fr,j,3));

				}

				printf("%s\n",query);

				snprintf(query,200,"%s -A %s_out -j RETURN -s %s ",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res_fr,j,0));

				if (strlen(PQgetvalue(res_fr,j,2))>0)
				{
					strcat(query," --protocol ");
					strcat(query,PQgetvalue(res_fr,j,2));
				}

				if (strlen(PQgetvalue(res_fr,j,1))>0)
				{
					strcat(query," --source-port ");
					strcat(query,PQgetvalue(res_fr,j,1));
				}
				if (strlen(PQgetvalue(res_fr,j,3))>0)
				{
					strcat(query," --out-interface ");
					strcat(query,PQgetvalue(res_fr,j,3));

				}

				printf("%s\n",query);

			}
		/* normal accounting */
		snprintf(query,300,"select value from config where name='acct_src'");
		res1=PQexec(conn,query);
		for (j=0;j<PQntuples(res1);j++)
		{
			printf("%s -A %s_in -s %s\n",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0));
			printf("%s -A %s_out -d %s\n",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0));
		}
		snprintf(query,300,"select srcip,srcport,dstip,dstport,proto,iface,rule,prio from %s_in order by prio",PQgetvalue(res,i,0));
		res1=PQexec(conn,query);
		for (j=0;j<PQntuples(res1);j++)
		{
			snprintf(query,290,"%s -A %s_in -s %s -d %s",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0),PQgetvalue(res1,j,2));

			if (strlen(PQgetvalue(res1,j,4))>0)
			{
				strcat(query," --protocol ");
				strcat(query,PQgetvalue(res1,j,4));
			}

			if (strlen(PQgetvalue(res1,j,1))>0)
			{
				strcat(query," --source-port ");
				strcat(query,PQgetvalue(res1,j,1));
			}

			if (strlen(PQgetvalue(res1,j,3))>1)
			{
				strcat(query," --destination-port ");
				strcat(query,PQgetvalue(res1,j,3));
			}

			if (strlen(PQgetvalue(res1,j,5))>0)
			{
				strcat(query," --in-interface ");
				strcat(query,PQgetvalue(res1,j,5));
			}
			if (strlen(PQgetvalue(res1,j,6))>0)
			{
				strcat(query," -j ");
				strcat(query,PQgetvalue(res1,j,6));
			}


			printf("%s\n",query);
		}
		snprintf(query,300,"select srcip,srcport,dstip,dstport,proto,iface,rule,prio from %s_out order by prio",PQgetvalue(res,i,0));
		res1=PQexec(conn,query);
		for (j=0;j<PQntuples(res1);j++)
		{
			snprintf(query,290,"%s -A %s_out -s %s -d %s",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0),PQgetvalue(res1,j,2));

			if (strlen(PQgetvalue(res1,j,4))>0)
			{
				strcat(query," --protocol ");
				strcat(query,PQgetvalue(res1,j,4));
			}

			if (strlen(PQgetvalue(res1,j,1))>0)
			{
				strcat(query," --source-port ");
				strcat(query,PQgetvalue(res1,j,1));
			}

			if (strlen(PQgetvalue(res1,j,3))>1)
			{
				strcat(query," --destination-port ");
				strcat(query,PQgetvalue(res1,j,3));
			}

			if (strlen(PQgetvalue(res1,j,5))>0)
			{
				strcat(query," --out-interface ");
				strcat(query,PQgetvalue(res1,j,5));
			}
			if (strlen(PQgetvalue(res1,j,6))>0)
			{
				strcat(query," -j ");
				strcat(query,PQgetvalue(res1,j,6));
			}


			printf("%s\n",query);
		}


	}
	printf("%s -F ifc_in\n",IPCHAINS);
	printf("%s -F ifc_out\n",IPCHAINS);
	res=PQexec(conn,"select value from config where name='acct_iface'");
	for (i=0;i<PQntuples(res);i++)
	{

		printf("%s -A ifc_in --in-interface %s\n",IPCHAINS,PQgetvalue(res,i,0));
		printf("%s -A ifc_out --out-interface %s\n",IPCHAINS,PQgetvalue(res,i,0));

	}



	PQfinish(conn);
	return 0;
}
